<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Delete ServiceType
 * @subpackage Services
 */
class Delete extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named deleteReturnDocumentsProfile
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteReturnDocumentsProfile $parameters
     * @return \StructType\DeleteReturnDocumentsProfileResponse|bool
     */
    public function deleteReturnDocumentsProfile(\StructType\DeleteReturnDocumentsProfile $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->deleteReturnDocumentsProfile($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named deleteParcelContent
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteParcelContent $parameters
     * @return \StructType\DeleteParcelContentResponse|bool
     */
    public function deleteParcelContent(\StructType\DeleteParcelContent $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->deleteParcelContent($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named deleteChecklistTemplate
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteChecklistTemplate $parameters
     * @return \StructType\DeleteChecklistTemplateResponse|bool
     */
    public function deleteChecklistTemplate(\StructType\DeleteChecklistTemplate $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->deleteChecklistTemplate($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named deleteShopEZwroty
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\DeleteShopEZwroty $parameters
     * @return \StructType\DeleteShopEZwrotyResponse|bool
     */
    public function deleteShopEZwroty(\StructType\DeleteShopEZwroty $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->deleteShopEZwroty($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\DeleteChecklistTemplateResponse|\StructType\DeleteParcelContentResponse|\StructType\DeleteReturnDocumentsProfileResponse|\StructType\DeleteShopEZwrotyResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
